#include <vcl.h>
#pragma hdrstop
#include "Unit1.h"
#include "mpusbapi.h"
char vid_pid[]= "vid_04d8&pid_000c";
char out_pipe[]= "\\MCHP_EP1";
char in_pipe[]= "\\MCHP_EP1";
HINSTANCE libHandle;
HANDLE myOutPipe;
HANDLE myInPipe;

AnsiString CheckInvalidHandle(void);
void LoadDLL(void);
void UnloadDLL(void);
DWORD SendReceivePacket(BYTE *SendData, DWORD SendLength, BYTE *ReceiveData,
                    DWORD *ReceiveLength, UINT SendDelay, UINT ReceiveDelay);

#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}

//---------------------------------------------------------------------------

AnsiString CheckInvalidHandle(void){
    AnsiString ret = "ok";
    if(GetLastError() == ERROR_INVALID_HANDLE){
        MPUSBClose(myOutPipe);
        MPUSBClose(myInPipe);
        myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
    }else ret = "Error Code " + GetLastError();
    return ret;
}

//---------------------------------------------------------------------------

void LoadDLL(void){
    libHandle = NULL;
    libHandle = LoadLibrary("mpusbapi");
    if(libHandle == NULL){

    }else{
        MPUSBGetDLLVersion=(DWORD(*)(void))\
                    GetProcAddress(libHandle,"_MPUSBGetDLLVersion");
        MPUSBGetDeviceCount=(DWORD(*)(PCHAR))\
                    GetProcAddress(libHandle,"_MPUSBGetDeviceCount");
        MPUSBOpen=(HANDLE(*)(DWORD,PCHAR,PCHAR,DWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBOpen");
        MPUSBWrite=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBWrite");
        MPUSBRead=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBRead");
        MPUSBReadInt=(DWORD(*)(HANDLE,PVOID,DWORD,PDWORD,DWORD))\
                    GetProcAddress(libHandle,"_MPUSBReadInt");
        MPUSBClose=(BOOL(*)(HANDLE))GetProcAddress(libHandle,"_MPUSBClose");

        if((MPUSBGetDeviceCount == NULL) || (MPUSBOpen == NULL) ||
            (MPUSBWrite == NULL) || (MPUSBRead == NULL) ||
            (MPUSBClose == NULL) || (MPUSBGetDLLVersion == NULL) ||
            (MPUSBReadInt == NULL)){

            }
    }
    myOutPipe = MPUSBOpen(0,vid_pid,out_pipe,MP_WRITE,0);
    myInPipe = MPUSBOpen(0,vid_pid,out_pipe,MP_READ,0);
}

//----------------------------------------------------------------------------

void UnloadDLL(void)
{
    MPUSBClose(myOutPipe);
    MPUSBClose(myInPipe);
    myOutPipe = myInPipe = INVALID_HANDLE_VALUE;
}

//---------------------------------------------------------------------------

DWORD SendReceivePacket(BYTE *SendData, DWORD SendLength, BYTE *ReceiveData,
                    DWORD *ReceiveLength, UINT SendDelay, UINT ReceiveDelay){
    DWORD SentDataLength;
    DWORD ExpectedReceiveLength = *ReceiveLength;
    if(myOutPipe != INVALID_HANDLE_VALUE && myInPipe != INVALID_HANDLE_VALUE){
        if(MPUSBWrite(myOutPipe,SendData,SendLength,&SentDataLength,SendDelay)){
            if(MPUSBRead(myInPipe,ReceiveData, ExpectedReceiveLength,
                        ReceiveLength,ReceiveDelay)){
                if(*ReceiveLength == ExpectedReceiveLength){
                    return 1;   // Success!
                }else if(*ReceiveLength < ExpectedReceiveLength){
                    return 2;   // Partially failed, incorrect receive length
                }//end if else
            }else CheckInvalidHandle();
        }else CheckInvalidHandle();
    }//end if

    return 0;  // Operation Failed
}//end SendReceivePacket

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
    LoadDLL();        
}

//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    BYTE send_buf[64],receive_buf[64],set_out = 0x00;
    DWORD RecvLength=21;
    if(CheckBox1->Checked == true)set_out = set_out + 1;
    if(CheckBox2->Checked == true)set_out = set_out + 2;
    if(CheckBox3->Checked == true)set_out = set_out + 4;
    if(CheckBox4->Checked == true)set_out = set_out + 8;
    if(CheckBox5->Checked == true)set_out = set_out + 16;
    if(CheckBox6->Checked == true)set_out = set_out + 32;
    if(CheckBox7->Checked == true)set_out = set_out + 64;
    if(CheckBox8->Checked == true)set_out = set_out + 128;


    send_buf[0] = 0x37;      // Command
    send_buf[1] = set_out;
    SendReceivePacket(send_buf,2,receive_buf,&RecvLength,150,150);
    ProgressBar1->Position = receive_buf[2] * 256 + receive_buf[1];
    ProgressBar2->Position = receive_buf[4] * 256 + receive_buf[3];
    ProgressBar3->Position = receive_buf[6] * 256 + receive_buf[5];
    ProgressBar4->Position = receive_buf[8] * 256 + receive_buf[7];
    ProgressBar5->Position = receive_buf[10] * 256 + receive_buf[9];
    ProgressBar6->Position = receive_buf[12] * 256 + receive_buf[11];
    ProgressBar7->Position = receive_buf[14] * 256 + receive_buf[13];
    ProgressBar8->Position = receive_buf[16] * 256 + receive_buf[15];
    ProgressBar9->Position = receive_buf[18] * 256 + receive_buf[17];
    ProgressBar10->Position = receive_buf[20] * 256 + receive_buf[19];
    Label1->Caption = FloatToStr(ProgressBar1->Position / 204.6).SubString(0,4);
    Label2->Caption = FloatToStr(ProgressBar2->Position / 204.6).SubString(0,4);
    Label3->Caption = FloatToStr(ProgressBar3->Position / 204.6).SubString(0,4);
    Label4->Caption = FloatToStr(ProgressBar4->Position / 204.6).SubString(0,4);
    Label5->Caption = FloatToStr(ProgressBar5->Position / 204.6).SubString(0,4);
    Label6->Caption = FloatToStr(ProgressBar6->Position / 204.6).SubString(0,4);
    Label7->Caption = FloatToStr(ProgressBar7->Position / 204.6).SubString(0,4);
    Label8->Caption = FloatToStr(ProgressBar8->Position / 204.6).SubString(0,4);
    Label9->Caption = FloatToStr(ProgressBar9->Position / 204.6).SubString(0,4);
    Label10->Caption = FloatToStr(ProgressBar10->Position / 204.6).SubString(0,4);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)
{
    BYTE send_buf[64],receive_buf[64],set_out = 0x00;
    DWORD RecvLength=0;
    send_buf[0] = 0xFF;      // Command
    SendReceivePacket(send_buf,1,receive_buf,&RecvLength,150,150);
    Button1->Enabled = false;
    UnloadDLL();
    Timer2->Interval = 2500;         // 2.5   
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
    LoadDLL();
    Timer2->Interval = 0;
    Button1->Enabled = true;
}
//---------------------------------------------------------------------------

